#!/bin/bash

url_devel="http://svn.rocklinux-consulting.de/rock-linux/trunk/"
url_stable="http://svn.rocklinux-consulting.de/rock-linux/branches/2.0-stable/"
eval "url=\"\$url_$1\""; rev="$2"

if [ -z "$url" -a -z "$rev" ]; then
	echo "Usage: $0 <branch> <rev> { log | logv | diff | merge }"
	[ -n "$1" ] && echo "URL for branch '$1' not configured!"
	exit 0
fi
shift
shift

case "$1" in
	log)
		svn log -r $rev $url
		;;
	logv)
		svn log -vr $rev $url
		;;
	diff)
		svn diff -r $((rev-1)):$rev $url
		;;
	merge)
		{ echo; echo "Merged from $url:"; } > svnmerge.log
		svn log -r $rev $url | grep -v -- '^--*$' >> svnmerge.log
		svn merge -r $((rev-1)):$rev $url .
		echo "Please run 'svn commit -F svnmerge.log' now .."
		;;
	*)
		echo "Usage: $0 <branch> <rev> { log | logv | merge }"
		;;
esac

