#!/usr/bin/perl -w
# while read p; do ./votecheck.pl $p; done < <( ls open/ | cut -f1 -d. | tr _ / | grep .; )

use strict;
use English;

my (%v, %m, %t);

if ( open(V, "<data/$ARGV[0].votes") ) {
	while (<V>) {
		next unless /^([-+]) (\S+)$/;
		$v{$2} = $1;
	}
	close V;
}

my $file_is_unchecked;

sub check {
	my ($n, @p) = @_;
	my ($u, $txt);
	my $i = 0;

	foreach $u (@p) {
		if ( defined $v{$u} ) {
			$i++ if $v{$u} eq "+";
			$m{"<b>WARNING: $u voted against this patch!</b>"}=1 if $v{$u} eq "-";
		} else {
			$t{$u}=1;
		}
	}

	$file_is_unchecked = 0;

	if ( $i < $n ) {
		$txt = "Needs $n positive votes from (".(join "), (", @p).").";
		$txt =~ s/ 1 positive votes / a positive vote /;
		$txt =~ s/,([^,]*)$/ or$1/; $m{$txt}=1;
		return 0;
	}

	return $i > 0;
}

open(L, "lsdiff data/$ARGV[0].patch |") || die $!;
while (<L>) {
	chomp;

	# next if check(0, "clifford");
	$file_is_unchecked = 1;

	check(1, "fake", "clifford", "stefanp")
		if m,^(Documentation|scripts|architecture|misc|target)/,;

	#check(0)
	#	if m,^package/a-tui/,;

	check(1, "alanw")
		if m,^package/alanw/,;

	#check(0)
	#	if m,^package/alessandro/,;

	#check(0)
	#	if m,^package/alpha/,;

	check(1, "netrunner")
		if m,^package/avm/,;

	check(1, "fake", "clifford", "stefanp")
		if m,^package/base/,;

	check(1, "fake", "clifford", "stefanp")
		if m,^package/import/,;

	#check(0)
	#	if m,^package/be-el/,;

	check(1, "blindcoder")
		if m,^package/blindcoder/,;

	check(1, "clifford")
		if m,^package/clifford/,;

	check(1, "daja77")
		if m,^package/daja77/,;

	check(1, "nookie")
		if m,^package/daniel/,;

	check(1, "esden")
		if m,^package/esden/,;

	check(1, "fake")
		if m,^package/fake/,;

	check(1, "giftnuss")
		if m,^package/freedict/,;

	check(1, "jsaw")
		if m,^package/gnome14/,;

	check(1, "jsaw")
		if m,^package/gnome2/,;

	check(1, "hannes")
		if m,^package/hannes/,;

	check(1, "fake", "clifford", "stefanp")
		if m,^package/jimmy/,;

	check(1, "jsaw")
		if m,^package/jsaw/,;

	check(1, "kasc")
		if m,^package/kasc/,;

	check(1, "fake", "clifford", "stefanp")
		if m,^package/kde/,;

	check(1, "blindcoder")
		if m,^package/lvp/,;

	check(1, "mathieu")
		if m,^package/mathieu/,;

	#check(0)
	#	if m,^package/michiel/,;

	check(1, "fake")
		if m,^package/mips/,;

	check(1, "fake", "clifford", "stefanp")
		if m,^package/misc/,;

	check(1, "mnemoc")
		if m,^package/mnemoc/,;

	#check(0)
	#	if m,^package/nikolaus/,;

	#check(0)
	#	if m,^package/orphaned/,;

	check(1, "fake")
		if m,^package/powerpc/,;

	check(1, "praenti")
		if m,^package/praenti/,;

	check(1, "fake", "clifford", "stefanp")
		if m,^package/rene/,;

	check(1, "sirkull")
		if m,^package/sirkull/,;

	check(1, "fake")
		if m,^package/sparc/,;

	check(1, "stefanp")
		if m,^package/stefanp/,;

	check(1, "stf")
		if m,^package/stf/,;

	check(1, "teha")
		if m,^package/teha/,;

	#check(0)
	#	if m,^package/tibit/,;

	check(1, "tsa")
		if m,^package/tsa/,;

	check(1, "tschmidt")
		if m,^package/tschmidt/,;

	check(1, "fake", "clifford", "stefanp")
		if m,^package/x11/,;

	check(1, "fake", "clifford", "stefanp")
		if m,^package/x86/,;

	check(1, "fake", "clifford", "stefanp")
		if m,^package/xfce4/,;

	$m{"Don't know responsible user for $_!"} = 1
		if $file_is_unchecked;
}
close(L);

my @info = ();

if ( open(I, "<data/$ARGV[0].info") ) {
	while (<I>) {
		next if /^VOTECHECK: /;
		push @info, $_;
	}
	close I;
}

open(I, ">data/$ARGV[0].info") || die $!;
foreach (@info) { print I; }
foreach (keys %m) { print I "VOTECHECK: <font color=\"#aa0000\">$_</font>\n"; }
close I;

